########################################
#
# datapack by SNIGUR
#
########################################

function me2:mind/corridors
function me2:mind/piston_puzzle
function me2:mind/fill_space_puzzle

execute unless entity @a[tag=in_mind] run effect clear @a minecraft:night_vision
effect clear @a minecraft:mining_fatigue

execute as @a[tag=in_mind] at @s run effect give @s minecraft:mining_fatigue 2 10 true
execute as @a[tag=in_mind] at @s run effect give @s minecraft:night_vision 10 5 true

execute if blocks -1024 77 -993 -1016 85 -993 -1024 77 -991 all run tag @a add cyan_done

execute if entity @e[tag=cyan_done,tag=!cyan_escaped] run scoreboard objectives add cyan dummy
execute if entity @e[tag=cyan_done,tag=!cyan_escaped] run scoreboard players add @a cyan 1

execute if entity @e[tag=cyan_done,scores={cyan=20}] run particle falling_dust cyan_concrete -1020 86 -995 2 0.1 1 1 200 force
execute if entity @e[tag=cyan_done,scores={cyan=40}] run fill -1025 76 -994 -1015 86 -994 minecraft:white_concrete 
execute if entity @e[tag=cyan_done,scores={cyan=40}] run setblock -1020 76 -1000 air
execute if entity @e[tag=cyan_done,scores={cyan=40}] run tag @a add cyan_escaped
execute if entity @e[tag=cyan_done,scores={cyan=40}] run scoreboard objectives remove cyan

execute if blocks -1044 136 -989 -1036 136 -981 -1044 149 -989 all run tag @a add orange_done

execute if entity @e[tag=orange_done,tag=!orange_escaped] run scoreboard objectives add orange dummy
execute if entity @e[tag=orange_done,tag=!orange_escaped] run scoreboard players add @a orange 1

execute if entity @e[tag=orange_done,scores={orange=20}] run particle falling_dust orange_concrete -1040 146 -985 4 1 4 1 200 force
execute if entity @e[tag=orange_done,scores={orange=40}] run fill -1035 136 -990 -1045 136 -980 minecraft:white_concrete 
execute if entity @e[tag=orange_done,scores={orange=40}] run tag @a add orange_escaped
execute if entity @e[tag=orange_done,scores={orange=40}] run scoreboard objectives remove orange

execute if entity @e[tag=orange_done,tag=cyan_done,x=-1005,y=60,z=-1005,dx=11,dy=7,dz=11] run tag @a add in_room
execute if entity @e[tag=orange_done,tag=cyan_done,x=-1005,y=92,z=-1005,dx=11,dy=7,dz=11] run tag @a add in_room
execute if entity @e[tag=orange_done,tag=cyan_done,x=-1005,y=60,z=-1005,dx=11,dy=7,dz=11,tag=!key_exist] run scoreboard objectives add mind_room dummy
execute if entity @e[tag=orange_done,tag=cyan_done,x=-1005,y=92,z=-1005,dx=11,dy=7,dz=11,tag=!key_exist] run scoreboard objectives add mind_room dummy

execute if entity @e[tag=orange_done,tag=cyan_done,tag=in_room,tag=!key_exist] run scoreboard players add @a mind_room 1

execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=20}] run setblock -1000 91 -1000 air destroy
execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=20}] run setblock -1000 99 -1000 air destroy
execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=20}] run setblock -1000 67 -1000 air destroy
execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=20}] run setblock -1000 59 -1000 air destroy

execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=30}] run playsound minecraft:entity.wither.spawn master @a -1000 63 -1000 1 0 0
execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=30}] run playsound minecraft:entity.wither.spawn master @a -1000 95 -1000 1 0 0
execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=30}] run particle minecraft:reverse_portal -1000 95.2 -1000 0 0 0 0.5 100 force @a
execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=30}] run particle minecraft:reverse_portal -1000 63.2 -1000 0 0 0 0.5 100 force @a
execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=30}] run particle minecraft:large_smoke -1000 95.2 -1000 0 0 0 0.5 100 force @a
execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=30}] run particle minecraft:large_smoke -1000 63.2 -1000 0 0 0 0.5 100 force @a
execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=30}] run summon item -1000 63 -1000 {Tags:["mind_key"],NoGravity:1b,Age:-32768,Item:{id:"minecraft:player_head",Count:1b,tag:{display:{Name:"{\"text\":\"Key to the past\",\"color\":\"black\",\"bold\":true,\"italic\":false}"},SkullOwner:{Id:[I;868282432,757221404,-1260649338,664128144],Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvNTc5ZDBlOTZjMzUxZTJlMmQ5MDQyYTQ2ODJkZWM0MzBjNGU1MjI1NmVkNzdjZjgwYmQwMjY3ZjdjYWJlMzMwMCJ9fX0="}]}}}}}
execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=30}] run summon item -1000 95 -1000 {Tags:["mind_key"],NoGravity:1b,Age:-32768,Item:{id:"minecraft:player_head",Count:1b,tag:{display:{Name:"{\"text\":\"Key to the past\",\"color\":\"black\",\"bold\":true,\"italic\":false}"},SkullOwner:{Id:[I;868282432,757221404,-1260649338,664128144],Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvNTc5ZDBlOTZjMzUxZTJlMmQ5MDQyYTQ2ODJkZWM0MzBjNGU1MjI1NmVkNzdjZjgwYmQwMjY3ZjdjYWJlMzMwMCJ9fX0="}]}}}}}

execute as @e[tag=mind_key] at @s run particle minecraft:item crying_obsidian ~ ~0.2 ~ 0 0 0 0.1 20 force @a

execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=30}] run tag @a add key_exist

execute if entity @e[tag=orange_done,tag=cyan_done,scores={mind_room=30..}] run scoreboard objectives remove mind_room

execute if entity @a[tag=!returned,tag=orange_done,tag=cyan_done,nbt={Inventory:[{id:"minecraft:player_head",Count:1b,tag:{SkullOwner:{Id:[I;868282432,757221404,-1260649338,664128144],Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvNTc5ZDBlOTZjMzUxZTJlMmQ5MDQyYTQ2ODJkZWM0MzBjNGU1MjI1NmVkNzdjZjgwYmQwMjY3ZjdjYWJlMzMwMCJ9fX0="}]}}}}]}] run function me2:mind/return
